// Generated by CoffeeScript 1.6.2
var ChangeDecor, ModelDecor, dref, escapeHTML, type, _, _ref,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

_ = require("underscore");

ChangeDecor = require("./change");

escapeHTML = require("../../utils/escapeHTML");

type = require("type-component");

dref = require("dref");

ModelDecor = (function(_super) {
  __extends(ModelDecor, _super);

  function ModelDecor() {
    this._elementValue = __bind(this._elementValue, this);
    this._onValueChange = __bind(this._onValueChange, this);
    this._onChange = __bind(this._onChange, this);
    this._onElementChange = __bind(this._onElementChange, this);    _ref = ModelDecor.__super__.constructor.apply(this, arguments);
    return _ref;
  }

  /*
  */


  ModelDecor.prototype.bind = function() {
    ModelDecor.__super__.bind.call(this);
    (this.$element = $(this.element)).bind(ChangeDecor.events, this._onElementChange);
    return this._onChange(this.clip.get("model"));
  };

  /*
  */


  ModelDecor.prototype._onElementChange = function(event) {
    var _this = this;

    event.stopPropagation();
    clearTimeout(this._changeTimeout);
    return this._changeTimeout = setTimeout((function() {
      var model, name, ref, value;

      value = _this._parseValue(_this._elementValue());
      name = _this._elementName();
      model = _this.clip.get("model");
      if (_this.clip.get("bothWays") !== false) {
        ref = name || (_this.refs.length ? _this.refs[0] : void 0);
        if (!name) {
          model = _this.context;
        }
        if (model) {
          if (model.set) {
            return model.set(ref, value);
          } else {
            return dref.set(model, ref, value);
          }
        }
      }
    }), 5);
  };

  /*
  */


  ModelDecor.prototype.dispose = function() {
    var _ref1, _ref2;

    if ((_ref1 = this._modelBinding) != null) {
      _ref1.dispose();
    }
    return (_ref2 = this.$element) != null ? _ref2.unbind(ChangeDecor.events, this._onElementChange) : void 0;
  };

  /*
  */


  ModelDecor.prototype._onChange = function(model) {
    var name, _ref1;

    name = this._elementName();
    if ((_ref1 = this._modelBinding) != null) {
      _ref1.dispose();
    }
    if (name) {
      return this._modelBinding = model != null ? model.bind(name).to(this._onValueChange).now() : void 0;
    } else {
      return this._onValueChange(model);
    }
  };

  /*
  */


  ModelDecor.prototype._onValueChange = function(value) {
    return this._elementValue(this._parseValue(value));
  };

  /*
  */


  ModelDecor.prototype._parseValue = function(value) {
    var v;

    if ((value == null) || value === "") {
      return void 0;
    }
    if (isNaN(v = Number(value))) {
      return value;
    } else {
      return v;
    }
  };

  /*
  */


  ModelDecor.prototype._elementValue = function(value) {
    var isInput;

    if (value == null) {
      value = "";
    }
    isInput = Object.prototype.hasOwnProperty.call(this.element, "value") || /input|textarea|checkbox/.test(this.element.nodeName.toLowerCase());
    if (!arguments.length) {
      if (isInput) {
        return this._checkedOrValue();
      } else {
        return this.element.innerHTML;
      }
    }
    this.currentValue = value;
    if (isInput) {
      return this._checkedOrValue(value);
    } else {
      return this.element.innerHTML = value;
    }
  };

  /*
  */


  ModelDecor.prototype._elementName = function() {
    return $(this.element).attr("name");
  };

  /*
  */


  ModelDecor.prototype._checkedOrValue = function(value) {
    var isCheckbox, isRadio, isRadioOrCheckbox;

    isCheckbox = /checkbox/.test(this.element.type);
    isRadio = /radio/.test(this.element.type);
    isRadioOrCheckbox = isCheckbox || isRadio;
    if (!arguments.length) {
      if (isRadioOrCheckbox) {
        return $(this.element).val();
      } else {
        return this.element.value;
      }
    }
    if (isRadioOrCheckbox) {
      if (isRadio) {
        if (String(value) === String($(this.element).val())) {
          return $(this.element).prop("checked", true);
        }
      } else {
        return this.element.checked = value;
      }
    } else {
      return this.element.value = value;
    }
  };

  return ModelDecor;

})(require("./dataBind"));

module.exports = ModelDecor;
